#include <iostream>
#include "specific_distributions.h"

using namespace std;

void NormalDistribution::print() const{
  cout<<"normal distribution.\n\n";
  cout<<"mu="<<mu;
  if(fixedmu){
    cout<<"\t fixed";
  };
  cout<<"\nsigma="<<sigma;
  if(fixedsig){
    cout<<"\t fixed";
  };
  cout<<"\nParameter of interest: ";
  switch(mainpar){
  case 0:
    cout<<"mu\n";
    return;
  case 1:
    cout<<"sigma\n";
    return;
  case 2:
    cout<<"VaR at "<<VaR_at<<" level.\n";
    return;
  default:
    cout<<"No main parameter selected. This should not happen.\n";
  };
};


void ParetoType1Distribution::print() const{
  cout<<"Pareto distribution.\n\n";
  cout<<"alpha="<<alpha;
  if(fixedalpha){
    cout<<"\t fixed";
  };
  cout<<"\nmin="<<min;
  if(fixedmin){
    cout<<"\t fixed";
  };
  cout<<"\nParameter of interest: ";
  switch(mainpar){
  case 0:
    cout<<"alpha\n";
    return;
  case 1:
    cout<<"min\n";
    return;
  case 2:
    cout<<"VaR at "<<VaR_at<<" level.\n";
    return;
  default:
    cout<<"No main parameter selected. This should not happen.\n";
  };
};


void PoissonDistribution::print() const{
  cout<<"Poisson distribution.\n\n";
  cout<<"lambda="<<lambda<<"\n";
};



void LogNormalPoissonDistribution::print() const{
  cout<<"Log-Normal-Poisson distribution.\n\n";
  cout<<"mu="<<mu;
  if(fixedmu){
    cout<<"\t fixed";
  };
  cout<<"\nsigma="<<sigma;
  if(fixedsig){
    cout<<"\t fixed";
  };
  cout<<"\nParameter of interest: ";
  switch(mainpar){
  case 0:
    cout<<"mu\n";
    return;
  case 1:
    cout<<"sigma\n";
    return;
  case 2:
    cout<<"VaR at "<<VaR_at<<" level.\n";
    return;
  default:
    cout<<"No main parameter selected. This should not happen.\n";
  };
};

