#ifndef GENERAL_H
#define GENERAL_H

#include <cstddef>

#include <cstdlib>
//generally useful functions


inline int compareLongDouble(const void *p1,const void *p2){
  if(*((long double *)p1)<*((long double *)p2)){
    return -1;
  }else if(*((long double *)p1)>*((long double *)p2)){
    return 1;
  }else{
    return 0;
  };
};


inline int compareUnsignedInt(const void *p1,const void *p2){
  if(*((unsigned int *)p1)<*((unsigned int *)p2)){
    return -1;
  }else if(*((unsigned int *)p1)>*((unsigned int *)p2)){
    return 1;
  }else{
    return 0;
  };
};


class dblll{
  long double val;
  dblll *next;
public:
  dblll(long double v){val=v;next=NULL;};
  dblll(long double v,dblll *nxt){val=v;next=nxt;};
  void insert(long double v){dblll *ins=new dblll(val,next);next=ins;val=v;};
  ~dblll(){if(next){delete(next);};};
  unsigned int length(unsigned int ans=0){ans++;if(next==NULL){return(ans);}else{return(next->length(ans));};};
  void write(long double *to){*to=val;if(next!=NULL){next->write(to+1);};};
};


class uill{
  unsigned int val;
  uill *next;
public:
  uill(unsigned int v){val=v;next=NULL;};
  uill(unsigned int v,uill *nxt){val=v;next=nxt;};
  void insert(unsigned int v){uill *ins=new uill(val,next);next=ins;val=v;};
  ~uill(){if(next){delete(next);};};
  unsigned int length(unsigned int ans=0){ans++;if(next==NULL){return(ans);}else{return(next->length(ans));};};
  void write(unsigned int *to){*to=val;if(next!=NULL){next->write(to+1);};};
};

//insertions happen at the front.


class dblctll{
  long double val;
  unsigned int freq;
  dblctll *next;
public:
  dblctll(long double v,unsigned int i){val=v;freq=i;next=NULL;};
  dblctll(long double v,unsigned int i,dblctll *nxt){val=v;freq=i;next=nxt;};
  void insert(long double v,unsigned int i){dblctll *ins=new dblctll(val,freq,next);next=ins;val=v;freq=i;};
  ~dblctll(){if(next){delete(next);};};
  unsigned int length(unsigned int ans=0){ans++;if(next==NULL){return(ans);}else{return(next->length(ans));};};
  void write(long double *to,unsigned int *frq){*to=val;*frq=freq;if(next!=NULL){next->write(to+1,frq+1);};};
};

class uictll{
  unsigned int val;
  unsigned int freq;
  uictll *next;
public:
  uictll(unsigned int v,unsigned int i){val=v;freq=i;next=NULL;};
  uictll(unsigned int v,unsigned int i,uictll *nxt){val=v;freq=i;next=nxt;};
  void insert(unsigned int v,unsigned int i){uictll *ins=new uictll(val,freq,next);next=ins;val=v;freq=i;};
  ~uictll(){if(next){delete(next);};};
  unsigned int length(unsigned int ans=0){ans++;if(next==NULL){return(ans);}else{return(next->length(ans));};};
  void write(unsigned int *to,unsigned int *freqs){*to=val;*freqs=freq;if(next!=NULL){next->write(to+1,freqs+1);};};
};
#endif
