#ifndef TDISTRIBUTION_H
#define TDISTRIBUTION_H

#include "data.h"
#include "distributions.h"

//ParetoType1 Distribution

#define SUPERCONSTRUCT Distribution("t",datatype(CONTINUOUS_DATA,LIST|FREQUENCY_TABLE|GROUPED),3,4)


const char *const tvalidparnames[]={"mu","sigma","degrees_of_freedom","VaR@"};

class TDistribution: public Distribution{
protected:
  long double mu;
  long double sigma;
  long double degreesoffreedom;
  char fixedmu;
  char fixedsigma;
  char fixeddegreesoffreedom;
  unsigned int mainpar;
  long double VaR_at;
public:
 TDistribution(const TDistribution &orig):SUPERCONSTRUCT,mu(orig.mu),sigma(orig.sigma),degreesoffreedom(orig.degreesoffreedom),fixedmu(orig.fixedmu),fixedsigma(orig.fixedsigma),fixeddegreesoffreedom(orig.fixeddegreesoffreedom),mainpar(orig.mainpar),VaR_at(orig.VaR_at){};
 TDistribution(long double m,long double s,long double dof):SUPERCONSTRUCT,mu(m),sigma(s),degreesoffreedom(dof),fixedmu(0),fixedsigma(0),fixeddegreesoffreedom(1),mainpar(0),VaR_at(0){};
 TDistribution():SUPERCONSTRUCT,mu(0),sigma(1),degreesoffreedom(3),fixedmu(0),fixedsigma(0),fixeddegreesoffreedom(1),mainpar(0),VaR_at(0){};
  virtual ~TDistribution(){};
  virtual unsigned int numpars() const{return 3;};
  virtual unsigned int numvalidpars() const{return 4;};
  virtual const char *const*validparnames() const{return tvalidparnames;};
  virtual long double* dist(const Data&dat) const;
  virtual long double* survive(const Data&dat) const;
  virtual long double *likelihood(const Data &dat) const;
  virtual long double quant(long double p) const;
  virtual Data* simulate(unsigned int n) const;  
  virtual long double parval() const;
  virtual long double parval(unsigned int i,long double at) const;
  virtual void setfixed(unsigned int i);
  virtual void setfixed(unsigned int i,long double val);
  virtual void unfix(unsigned int i);
  virtual void setmain(unsigned int i,long double at);
  virtual unsigned int numestpars() const;
  virtual TDistribution* copy() const;
  virtual void estimate(const Data &dat);

  virtual distSummary Rsummary()const;

  virtual void print() const;
};

#undef SUPERCONSTRUCT
#endif
