#include "data.h"
#include <cstdlib>
#include <iosfwd>

//This could probably be done better with templates.
//Defines different types of data that might be encountered.



class Frequency_Data: public Data{
 public:
  unsigned int *freq;
 Frequency_Data(unsigned int n,unsigned int *f):Data(n),freq(f){};
  virtual void subsample(unsigned int size);  
  virtual void concat(const Data *cdat)=0;
  virtual ~Frequency_Data(){if(freq){delete[] freq;};};
  virtual void sort()=0;
  virtual void write(std::ostream &to, unsigned int numcols)=0;
  virtual Frequency_Data* copy() const=0;
};



class Discrete_Individual_Data: public Data{
 public:
  //  datatype typ;
  //  unsigned int n;
  unsigned int *data;
  virtual const void* getvalues() const;
  virtual const unsigned int* getfreqs() const;
 Discrete_Individual_Data():Data(0),data(NULL){typ=datatype(DISCRETE_DATA,LIST);};
 Discrete_Individual_Data(unsigned int len,unsigned int *vals):Data(len),data(vals){typ=datatype(DISCRETE_DATA,LIST);};
    virtual void read(std::istream &in);
  virtual void concat(const Data *cdat);
  virtual ~Discrete_Individual_Data(){if(data){delete[] data;};};
  virtual void sort();
  virtual void write(std::ostream &to, unsigned int numcols);
  virtual Discrete_Individual_Data* copy() const;
};


class Continuous_Individual_Data: public Data{
 public:
  //  datatype typ;
  //  unsigned int n;
  long double *data;
  virtual const void* getvalues() const;
  virtual const unsigned int* getfreqs() const;
 Continuous_Individual_Data():Data(0),data(NULL){typ=datatype(CONTINUOUS_DATA,LIST);};
 Continuous_Individual_Data(unsigned int len,long double *vals):Data(len),data(vals){typ=datatype(CONTINUOUS_DATA,LIST);};
  virtual void read(std::istream &in);
  virtual void concat(const Data *cdat);
  virtual ~Continuous_Individual_Data(){if(data){delete[] data;};};
  virtual void sort();
  virtual void write(std::ostream &to, unsigned int numcols);
  virtual Continuous_Individual_Data* copy() const;
};





class Discrete_Frequency_Data: public Frequency_Data{
 public:
  //  datatype typ;
  //  unsigned int n;
  unsigned int *data;
  virtual const void* getvalues() const;
  virtual const unsigned int* getfreqs() const;
  //  virtual void subsample(unsigned int size);  
 Discrete_Frequency_Data():Frequency_Data(0,NULL),data(NULL){typ=datatype(DISCRETE_DATA,FREQUENCY_TABLE);};
 Discrete_Frequency_Data(unsigned int len,unsigned int *f,unsigned int *vals):Frequency_Data(len,f),data(vals){typ=datatype(DISCRETE_DATA,FREQUENCY_TABLE);};
  virtual void read(std::istream &in);
  virtual void concat(const Data *cdat);
  virtual ~Discrete_Frequency_Data(){if(data){delete[] data;};  };
  virtual void sort();
  virtual void write(std::ostream &to, unsigned int numcols);
  virtual Discrete_Frequency_Data* copy() const;
};


class Continuous_Frequency_Data: public Frequency_Data{
 public:
  //  datatype typ;
  //  unsigned int n;
  long double *data;
  virtual const void* getvalues() const;
  virtual const unsigned int* getfreqs() const;
 Continuous_Frequency_Data():Frequency_Data(0,NULL),data(NULL){typ=datatype(CONTINUOUS_DATA,FREQUENCY_TABLE);};
 Continuous_Frequency_Data(unsigned int len,unsigned int *f,long double *vals):Frequency_Data(len,f),data(vals){typ=datatype(CONTINUOUS_DATA,FREQUENCY_TABLE);};
  virtual void read(std::istream &in);
  virtual void concat(const Data *cdat);
  virtual ~Continuous_Frequency_Data(){if(data){delete[] data;};  };
  virtual void sort();
  virtual void write(std::ostream &to, unsigned int numcols);
  virtual Continuous_Frequency_Data* copy() const;
};




class Discrete_Grouped_Data: public Frequency_Data{
 public:
  //  datatype typ;
  //  unsigned int n;
  unsigned int *cutoffs;
  virtual const void* getvalues() const;
  virtual const unsigned int* getfreqs() const;
  //  virtual void subsample(unsigned int size);  
 Discrete_Grouped_Data():Frequency_Data(0,NULL),cutoffs(NULL){typ=datatype(DISCRETE_DATA,GROUPED);};
 Discrete_Grouped_Data(unsigned int len,unsigned int *f,unsigned int *vals):Frequency_Data(len,f),cutoffs(vals){typ=datatype(DISCRETE_DATA,GROUPED);};
  virtual void read(std::istream &in);
  virtual void concat(const Data *cdat);
  virtual ~Discrete_Grouped_Data(){if(cutoffs){delete[] cutoffs;};      };
  virtual void sort();
  virtual void write(std::ostream &to, unsigned int numcols);
  virtual Discrete_Grouped_Data* copy() const;
};


class Continuous_Grouped_Data: public Frequency_Data{
 public:
  //  datatype typ;
  //  unsigned int n;
  long double *cutoffs;
  virtual const void* getvalues() const;
  virtual const unsigned int* getfreqs() const;
 Continuous_Grouped_Data():Frequency_Data(0,NULL),cutoffs(NULL){typ=datatype(CONTINUOUS_DATA,GROUPED);};
 Continuous_Grouped_Data(unsigned int len,unsigned int *f,long double *vals):Frequency_Data(len,f),cutoffs(vals){typ=datatype(CONTINUOUS_DATA,GROUPED);};
  virtual void read(std::istream &in);
  virtual void concat(const Data *cdat);
  virtual ~Continuous_Grouped_Data(){if(cutoffs){delete[] cutoffs;};  };
  virtual void sort();
  virtual void write(std::ostream &to, unsigned int numcols);
  virtual Continuous_Grouped_Data* copy() const;
};


