#include <cstdlib>
#ifndef TESTS_h
#define TESTS_h 1


extern long double adcval;

extern long double kscval;

class Distribution;
class DiscreteDistribution;
class MultivariateDiscreteDistribution;

typedef long double (*AdequacyStat)(unsigned int,const long double *,const Distribution &);


typedef char (*AdequacyTest)(unsigned int,const void*,const Distribution &);

typedef char (*DiscreteAdequacyTest)(unsigned int,const void*,const DiscreteDistribution &);

typedef char (*RegressionAdequacyTest)(unsigned int,const void*,const RegressionModel &);


AdequacyTest read_adequacy_test(const char*  testname,const Distribution &dist);

DiscreteAdequacyTest read_discrete_adequacy_test(const char*  testname,const DiscreteDistribution &dist);


RegressionAdequacyTest read_regression_test(const char*  testname,const RegressionModel &dist);

AdequacyTest switchtojackknife(AdequacyTest adequacy_test);

AdequacyTest switchtogrouped(AdequacyTest adequacy_test);

DiscreteAdequacyTest switchtojackknife(DiscreteAdequacyTest adequacy_test);

DiscreteAdequacyTest switchtogrouped(DiscreteAdequacyTest adequacy_test);

void sortedsubsample(unsigned int n,unsigned int x,unsigned int *to);

void sortedsubsample(unsigned int n,const unsigned int *counts,unsigned int x,unsigned int *to);

void sortedjackknife(unsigned int n,unsigned int x,const long double *data,long double *to);

void sortedjackknife(unsigned int n,unsigned int x,const unsigned int *data,unsigned int *to);

void   sortedjackknife(unsigned int n,const unsigned int *counts,unsigned int x,unsigned int *to);

void jackknifecount(unsigned int n,unsigned int x,unsigned int *to);

unsigned int rbinom(unsigned int n,long double p);

unsigned int rbinom_fast(unsigned int n,long double p);

long double findmle_sample_bias_normal(unsigned int n,long double *samp,unsigned int ncut,long double *cutoffs,long double *nn=NULL);

#endif
